```markdown
# README

## Overview
This repository (or zip file) contains the scripts and data needed to reproduce the figures included in the paper. The contents are organized by figure number:

- **Figure 3**: Both the dataset and the R script are provided to fully reproduce the plot.  
- **Figures 4–7**: The underlying data for these figures are **proprietary** and therefore not shared in this repository. However, all the relevant scripts are included so that, if the data becomes available (or under the appropriate licensing agreement), the figures can be replicated.

If you are submitting this as part of a paper, please refer to the “Supplementary Information” section at the end of the paper for a link to the complete repository if it is publicly available on GitHub or another hosting service.

## Repository Structure
```
├── data
├── scripts
│   ├── figure3.R          # R script for reproducing Figure 3
│   ├── figure4-7_script.R          # R script for reproducing Figure 4 - Figure 7
│   ├── utilities.R          # utilities R script
└── README.md                     # This file
```

## Instructions for Reproducing Figures

### Figure 3
1. Open the R script located at `scripts/Figure3_script.R`.
2. Ensure that the working directory is set to the main folder (or adjust file paths in the script as needed).
3. Run the script. It will generate the final plot for Figure 3.

### Figures 4–7
1. Open each R script in `scripts/figure4-7_script.R`.
2. **Important**: The data required to reproduce these figures is **proprietary** and is **not** included in this repository (or zip file). You will see placeholders indicating where the data would be loaded.


## Notes on Proprietary Data
- For Figures 4–7, we are unable to share the raw data due to confidentiality agreements. Please contact the corresponding author if you require more information about the data or wish to discuss access under specific conditions.


```