# This file also updated mendizabal episcore

load('Fig3.RData')
library(ggsci)
celltype_col2 = pal_simpsons()(12)
p_2CT_gas <- rbind(frac_fisher_Gasparoni_M,frac.m2,frac.m,
                   frac_fisher_Gasparoni_M_EMixed) %>% full_join(tf) %>%
  mutate(CellType = ifelse(Var2 == "NeuN_pos","Neuron","Non-neuron"),
         newind  = paste0(true,CellType),
         Samples = ifelse(newind %in% c("0Neuron","1Non-neuron"), "NeuN- samples","NeuN+ samples"),
         Samples = factor(Samples, levels = c("NeuN+ samples", "NeuN- samples"))) %>% filter(bulk == "Gasparoni") %>% 
  mutate(bulk = paste("Bulk data:", bulk), sp = paste0(Var1,true)) %>%
  filter(ref %in% c("scMD","EpiSCORE","EMixed")) %>% unique() %>% group_by(CellType,Samples,ref) %>% summarize(value = mean(value)) %>%
  ggplot(aes(x = value, y = ref , fill = CellType)) +
  geom_col() +
  labs(y ="" , x="Estimated fraction",fill = "Cell Type") +ggpubr::theme_pubr()+
  facet_wrap(~Samples)+ theme(legend.position="top")+ggtitle("Gasparoni" )+
  scale_y_discrete(labels = c("scMD" = paste0("scMD\n MAE = ", gas_mae),
                              "EpiSCORE" = paste0("EpiSCORE\n MAE = ", gas_mae_epi),
                              "EMixed" = paste0("EMixed\n MAE = ", gas_mae_EMixed)))+scale_fill_manual(values=c("Non-neuron" = "#8491B4B2",
                                                                                                                 "Neuron" = celltype_col2[10]))+ 
  theme(legend.text=element_text(size = 15),text = element_text(size = 20))
data_hline <- data.frame(Samples = c("NeuN+ samples","NeuN- samples"),  # Create data for lines
                         hline = c(1,0))


############ new plot gui ##########


p_2CT_gui <- rbind(frac_fisher_Guintivano_M,frac.m2,frac.m,HiBED_Guintivano_M,frac_fisher_Guintivano_M_EMixed) %>% full_join(tf) %>%
  mutate(CellType = ifelse(Var2 == "NeuN_pos","Neuron","Non-neuron"),
         newind  = paste0(true,CellType),
         Samples = ifelse(newind %in% c("0Neuron","1Non-neuron"), "NeuN- samples","NeuN+ samples"),
         Samples = factor(Samples, levels = c("NeuN+ samples", "NeuN- samples"))) %>% filter(bulk != "Gasparoni") %>%
  mutate(bulk = paste("Bulk data:", bulk), sp = paste0(Var1,true),
         ref = factor(ref, levels=c("HiBED","EpiSCORE","scMD","EMixed"))) %>% 
  filter(ref %in% c("EMixed","scMD","EpiSCORE","HiBED")) %>%
  unique() %>% group_by(CellType,Samples,ref) %>% summarize(value = mean(value)) %>%
  ggplot(aes(x = value, y = ref , fill = CellType)) +
  geom_col() +
  labs(y ="" , x="Estimated fraction",fill = "Cell Type") +ggpubr::theme_pubr()+
  facet_wrap(~Samples)+ theme(legend.position="top")+ggtitle("Guintivano")+
  scale_y_discrete(labels = c("EMixed" = paste0("EMixed\n MAE = ", gui_mae_EMixed),
                              "scMD" = paste0("scMD\n MAE = ", gui_mae),
                              "EpiSCORE" = paste0("EpiSCORE\n MAE = ", gui_mae_epi),
                              "HiBED" = paste0("HiBED\n MAE = ", gui_mae_hibed)
  ))   +scale_fill_manual(values=c("Non-neuron" = "#8491B4B2",
                                   "Neuron" = celltype_col2[10]))+
theme(legend.text=element_text(size = 15),text = element_text(size = 20))


p_gui2_n2 <- rbind(frac_fisher_Guintivano_M,frac.m,HiBED_Guintivano_M,frac_fisher_Guintivano_M_EMixed) %>% full_join(tf) %>%
  mutate(CellType = ifelse(Var2 == "NeuN_pos","Neuron","Non-neuron"),
         newind  = paste0(true,CellType),
         Samples = ifelse(newind %in% c("0Neuron","1Non-neuron"), "NeuN- samples","NeuN+ samples")) %>% filter(bulk != "Gasparoni") %>% 
  mutate(bulk = paste("Bulk data:", bulk), sp = paste0(Var1,true)) %>%
  filter(ref %in% c("EMixed","scMD","EpiSCORE","HiBED")) %>%
  filter(CellType == "Neuron") %>%
  mutate(Samples = factor(Samples, level=c('NeuN+ samples', 'NeuN- samples')),
         ref = factor(ref, levels=c("EMixed","scMD","EpiSCORE","HiBED")))%>%  filter(Samples == "NeuN+ samples")%>%  
  ggboxplot( "Samples", "value", color = "ref", palette =c("#6D42C7","#32936F","#00AFBB", "#E7B800","#D64550"),add = "jitter")+
  xlab("")+ylab("Estimated Neuron fraction")+
  theme(legend.title=element_blank())+                                              # Add different lines to facet plot
  geom_hline(yintercept  = 1,linetype =2, color = "red")+ylim(0,1)+
  theme(legend.text=element_text(size = 15),text = element_text(size = 20)) +
  guides(color = guide_legend(nrow = 2))

p_gui2_o2 <- rbind(frac_fisher_Guintivano_M,frac.m,HiBED_Guintivano_M,frac_fisher_Guintivano_M_EMixed) %>% full_join(tf) %>%
  mutate(CellType = ifelse(Var2 == "NeuN_pos","Neuron","Non-neuron"),
         newind  = paste0(true,CellType),
         Samples = ifelse(newind %in% c("0Neuron","1Non-neuron"), "NeuN- samples","NeuN+ samples")) %>% 
  filter(bulk != "Gasparoni") %>% mutate(bulk = paste("Bulk data:", bulk), sp = paste0(Var1,true)) %>%
  filter(ref %in% c("EMixed","scMD","EpiSCORE","HiBED")) %>%
  filter(CellType != "Neuron") %>%
  mutate(Samples = factor(Samples, level=c('NeuN+ samples', 'NeuN- samples')),
         ref = factor(ref, levels=c("EMixed","scMD","EpiSCORE","HiBED")))%>%  filter(Samples != "NeuN+ samples")%>%  
  ggboxplot( "Samples", "value", color = "ref", palette =c("#6D42C7","#32936F","#00AFBB", "#E7B800","#D64550"),add = "jitter")+
  xlab("")+ylab("Estimated Non-neuron fraction")+
  theme(legend.title=element_blank())+                                              # Add different lines to facet plot
  geom_hline(yintercept  = 1,linetype =2, color = "red")+ylim(0,1)+
  theme(legend.text=element_text(size = 15),text = element_text(size = 20))+
  guides(color = guide_legend(nrow = 2))
p_gui22 <- ggarrange(p_gui2_n2,p_gui2_o2, common.legend = T)
p_gui22

# Gasparoni

p_2CT_gas <- rbind(frac_fisher_Gasparoni_M,frac.m2,HiBED_Gas,frac_fisher_Gasparoni_M_EMixed) %>% full_join(tf) %>%
  mutate(CellType = ifelse(Var2 == "NeuN_pos","Neuron","Non-neuron"),
         newind  = paste0(true,CellType),
         Samples = ifelse(newind %in% c("0Neuron","1Non-neuron"), "NeuN- samples","NeuN+ samples"),
         Samples = factor(Samples, levels = c("NeuN+ samples", "NeuN- samples")),
         ref = factor(ref, levels=c("HiBED","EpiSCORE","scMD","EMixed"))) %>% 
  filter(bulk == "Gasparoni") %>% mutate(bulk = paste("Bulk data:", bulk), sp = paste0(Var1,true)) %>%
  filter(ref %in% c("EMixed","scMD","EpiSCORE","HiBED")) %>% unique() %>% group_by(CellType,Samples,ref) %>% 
  summarize(value = mean(value)) %>%
  ggplot(aes(x = value, y = ref , fill = CellType)) +
  geom_col() +
  labs(y ="" , x="Estimated fraction",fill = "Cell Type") +ggpubr::theme_pubr()+
  facet_wrap(~Samples)+ theme(legend.position="top")+ggtitle("Gasparoni" )+
  scale_y_discrete(labels = c("EMixed" = paste0("EMixed\n MAE = ", gas_mae_EMixed),
                              "scMD" = paste0("scMD\n MAE = ", gas_mae),
                              "EpiSCORE" = paste0("EpiSCORE\n MAE = ", gas_mae_epi),
                              "HiBED" = paste0("HiBED\n MAE = ", gas_mae_hibed)))+scale_fill_manual(values=c("Non-neuron" = "#8491B4B2",
                                                                                                             "Neuron" = celltype_col2[10]))+
  theme(legend.text=element_text(size = 15),text = element_text(size = 20))




p_gas2_n2 <- rbind(frac_fisher_Gasparoni_M,frac.m2,HiBED_Gas,frac_fisher_Gasparoni_M_EMixed) %>% full_join(tf) %>%
  mutate(CellType = ifelse(Var2 == "NeuN_pos","Neuron","Non-neuron"),
         newind  = paste0(true,CellType),
         Samples = ifelse(newind %in% c("0Neuron","1Non-neuron"), "NeuN- samples","NeuN+ samples"),
         Samples = factor(Samples, levels = c("NeuN+ samples", "NeuN- samples")),
         ref = factor(ref, levels=c("EMixed","scMD","EpiSCORE","HiBED"))) %>% 
  filter(bulk == "Gasparoni") %>% mutate(bulk = paste("Bulk data:", bulk), sp = paste0(Var1,true)) %>%
  filter(ref %in% c("EMixed","scMD","EpiSCORE","HiBED")) %>%
  filter(CellType == "Neuron") %>%
  mutate(Samples = factor(Samples, level=c('NeuN+ samples', 'NeuN- samples')))%>%  filter(Samples == "NeuN+ samples")%>%  
  ggboxplot( "Samples", "value", color = "ref", palette =c("#6D42C7","#32936F","#00AFBB", "#E7B800","#D64550"),add = "jitter")+
  xlab("")+ylab("Estimated Neuron fraction")+
  theme(legend.title=element_blank())+                                              # Add different lines to facet plot
  geom_hline(yintercept  = 1,linetype =2, color = "red")+ylim(0,1)+
  theme(legend.text=element_text(size = 15),text = element_text(size = 20))+
  guides(color = guide_legend(nrow = 2))

p_gas2_o2 <- rbind(frac_fisher_Gasparoni_M,frac.m2,HiBED_Gas,frac_fisher_Gasparoni_M_EMixed) %>% full_join(tf) %>%
  mutate(CellType = ifelse(Var2 == "NeuN_pos","Neuron","Non-neuron"),
         newind  = paste0(true,CellType),
         Samples = ifelse(newind %in% c("0Neuron","1Non-neuron"), "NeuN- samples","NeuN+ samples")) %>% filter(bulk == "Gasparoni") %>% mutate(bulk = paste("Bulk data:", bulk), sp = paste0(Var1,true)) %>%
  filter(ref %in% c("EMixed","scMD","EpiSCORE","HiBED")) %>%
  filter(CellType != "Neuron") %>%
  mutate(Samples = factor(Samples, level=c('NeuN+ samples', 'NeuN- samples')),
         ref = factor(ref, levels=c("EMixed","scMD","EpiSCORE","HiBED")))%>%  filter(Samples != "NeuN+ samples")%>%  
  ggboxplot( "Samples", "value", color = "ref", palette =c("#6D42C7","#32936F","#00AFBB", "#E7B800","#D64550"),add = "jitter")+
  xlab("")+ylab("Estimated Non-neuron fraction")+
  theme(legend.title=element_blank())+                                              # Add different lines to facet plot
  geom_hline(yintercept  = 1,linetype =2, color = "red")+ylim(0,1)+
  theme(legend.text=element_text(size = 15),text = element_text(size = 20))
p_gas22 <- ggarrange(p_gas2_n2,p_gas2_o2,common.legend = T)+
  guides(color = guide_legend(nrow = 2))




p1 <- ggarrange(p_2CT_gui,p_2CT_gas,ncol = 1,nrow = 2,labels = c("a","b"),
                font.label = list(size = 32))
p22 <- ggarrange(p_gui22, p_gas22,ncol = 1,nrow = 2)

pfin <- ggarrange(p1,p22,ncol = 2,widths = c(2,1))
pfin
# save(frac_fisher_Gasparoni_M,frac.m2,frac.m,frac_fisher_Gasparoni_M_EMixed,tf,frac_fisher_Guintivano_M,HiBED_Guintivano_M,frac_fisher_Guintivano_M_EMixed,HiBED_Gas,gas_mae_hibed,gui_mae_hibed,gui_mae_EMixed,gui_mae,gui_mae_epi,gas_mae_EMixed,gas_mae,gas_mae_epi,file = 'Fig3.RData')
# ggsave("sorted_0422.pdf",pfin,width = 20,height = 10)

