#placeholder#
# load("EVAPR.RData")
p_emixed <- (p_dna+p_rna2)/2

rownames(p_emixed) <- rownames(p_dna)
colnames(p_emixed) <- colnames(p_dna)
# p_avg <- (p_dna+p_rna)/2

res_emixed_p <- reshape2::melt(p_dna)
colnames(res_emixed_p) <- c("Sample_Name","CellType","p_dna")
# colnames(nac_ens_RNA) = c("neutrophils","Endothelial","Excitatory lymphocytes","Inhibitory lymphocytes", "monocytes","eosinophils")
res_frac_atopy <- reshape2::melt(frac_atopy)
colnames(res_frac_atopy) <- c("Sample_Name","CellType","p_true")
# celltype_col = pal_lancet("lanonc")(9)
mae_value <- mean(abs(p_dna[,colnames(frac_atopy)]- frac_atopy), na.rm = TRUE)
mcor_value <-mean(diag(cor(p_dna[,colnames(frac_atopy)], frac_atopy, method = "s")))
mccc_value <- CTS_CCC(p_dna,frac_atopy)
round(get_CCC(p_dna,frac_atopy),3)



dat <- full_join(res_emixed_p, res_frac_atopy)%>%
  mutate(CellType = factor(CellType,level = c("neutrophils","lymphocytes","monocytes","eosinophils"))) %>%
  group_by(CellType) %>%
  mutate(y_min = min(min(p_dna),min(p_true)),
         x_min = y_min,
         y_max= max(max(p_dna),max(p_true)),
         x_max = y_max)
library(ggsci)
celltype_col2 = pal_simpsons()(10)

p1 <-  dat%>%
  ggscatter(y="p_dna",x="p_true",color = "CellType")+
  stat_cor(method = "spearman", size = 5,aes(label = after_stat(r.label)))+
  facet_wrap(~CellType,nrow = 1,scales = "free")+geom_abline(intercept = 0, slope = 1,linetype =2)+theme(legend.position = "none",
                                                                                                         aspect.ratio = 1)+
  ylab("Estimated fraction")+xlab("")+scale_color_manual(
    values = c("neutrophils" = celltype_col2[1],
               "lymphocytes" = celltype_col2[4],
               "monocytes" = celltype_col2[5],
               "eosinophils" = celltype_col2[6])
  )+theme(axis.text.x = element_text(angle = 45, vjust = 1, hjust=1),
          text = element_text(size = 22),axis.text = element_text(size = 20))+
  ggtitle(paste0("EMixed-DNA: Mean CCC = ",round(mccc_value,3)))+
  geom_blank(aes(y = y_min)) +
  geom_blank(aes(y = y_max))+
  geom_blank(aes(x = x_min)) +
  geom_blank(aes(x = x_max))
# 
# 
# ######### RNA ####
res_emixed_p <- reshape2::melt(p_rna2)
colnames(res_emixed_p) <- c("Sample_Name","CellType","p_rna")
# colnames(nac_ens_RNA) = c("neutrophils","Endothelial","Excitatory lymphocytes","Inhibitory lymphocytes", "monocytes","eosinophils")
res_frac_atopy <- reshape2::melt(frac_atopy)
colnames(res_frac_atopy) <- c("Sample_Name","CellType","p_true")
# celltype_col = pal_lancet("lanonc")(9)
mae_value <- mean(abs(p_rna2[,colnames(frac_atopy)]- frac_atopy), na.rm = TRUE)
mcor_value <-mean(diag(cor(p_rna2[,colnames(frac_atopy)], frac_atopy, method = "s")))
mccc_value <- CTS_CCC(p_rna2,frac_atopy)
round(get_CCC(p_rna2,frac_atopy),2)

dat <- full_join(res_emixed_p, res_frac_atopy)%>%
  mutate(CellType = factor(CellType,level = c("neutrophils","lymphocytes","monocytes","eosinophils"))) %>%
  group_by(CellType) %>%
  mutate(y_min = min(min(p_rna),min(p_true)),
         x_min = y_min,
         y_max= max(max(p_rna),max(p_true)),
         x_max = y_max)

p2 <-  dat%>%
  ggscatter(y="p_rna",x="p_true",color = "CellType")+
  stat_cor(method = "spearman", size = 5,aes(label = after_stat(r.label)))+
  facet_wrap(~CellType,nrow = 1,scales = "free")+geom_abline(intercept = 0, slope = 1,linetype =2)+theme(legend.position = "none",
                                                                                                         aspect.ratio = 1)+
  ylab("Estimated fraction")+xlab("")+scale_color_manual(
    values = c("neutrophils" = celltype_col2[1],
               "lymphocytes" = celltype_col2[4],
               "monocytes" = celltype_col2[5],
               "eosinophils" = celltype_col2[6])
  )+theme(axis.text.x = element_text(angle = 45, vjust = 1, hjust=1),
          text = element_text(size = 22),axis.text = element_text(size = 20))+
  ggtitle(paste0("EMixed-RNA: Mean CCC = ",round(mccc_value,3)))+
  geom_blank(aes(y = y_min)) +
  geom_blank(aes(y = y_max))+
  geom_blank(aes(x = x_min)) +
  geom_blank(aes(x = x_max))
# 
# 
# # ####### emixed #####
# 
res_emixed_p <- reshape2::melt(p_emixed)
colnames(res_emixed_p) <- c("Sample_Name","CellType","p_emixed")
# colnames(nac_ens_emixed) = c("neutrophils","Endothelial","Excitatory lymphocytes","Inhibitory lymphocytes", "monocytes","eosinophils")
res_frac_atopy <- reshape2::melt(frac_atopy)
colnames(res_frac_atopy) <- c("Sample_Name","CellType","p_true")
# celltype_col = pal_lancet("lanonc")(9)
mae_value <- mean(abs(p_emixed[,colnames(frac_atopy)]- frac_atopy), na.rm = TRUE)
mcor_value <-mean(diag(cor(p_emixed[,colnames(frac_atopy)], frac_atopy, method = "s")))
mccc_value <- CTS_CCC(p_emixed,frac_atopy)
round(get_CCC(p_emixed,frac_atopy),2)

dat <- full_join(res_emixed_p, res_frac_atopy)%>%
  mutate(CellType = factor(CellType,level = c("neutrophils","lymphocytes","monocytes","eosinophils"))) %>%
  group_by(CellType) %>%
  mutate(y_min = min(min(p_emixed),min(p_true)),
         x_min = y_min,
         y_max= max(max(p_emixed),max(p_true)),
         x_max = y_max)

p3 <-  dat%>%
  ggscatter(y="p_emixed",x="p_true",color = "CellType")+
  stat_cor(method = "spearman", size = 5,aes(label = after_stat(r.label)))+
  facet_wrap(~CellType,nrow = 1,scales = "free")+geom_abline(intercept = 0, slope = 1,linetype =2)+theme(legend.position = "none",
                                                                                                         aspect.ratio = 1)+
  ylab("Estimated fraction")+xlab("Measured fraction")+scale_color_manual(
    values = c("neutrophils" = celltype_col2[1],
               "lymphocytes" = celltype_col2[4],
               "monocytes" = celltype_col2[5],
               "eosinophils" = celltype_col2[6])
  )+theme(axis.text.x = element_text(angle = 45, vjust = 1, hjust=1),
          text = element_text(size = 22),axis.text = element_text(size = 20))+
  ggtitle(paste0("EMixed: Mean CCC = ",round(mccc_value,3)))+
  geom_blank(aes(y = y_min)) +
  geom_blank(aes(y = y_max))+
  geom_blank(aes(x = x_min)) +
  geom_blank(aes(x = x_max))

# 
pros2 <- ggarrange(p1,p2,p3,nrow = 4,ncol = 1,common.legend = T,labels = c("a","b","c"),
                   font.label = list(size = 30))
# pros2
ggsave("/storage/windows-backup/D drive/Manqi/EM/Figure/Paper/EVAPR_EMixed_scatter_CSadj_0911_2.pdf",pros2,width = 15,height = 20)
#ggsave("/storage/windows-backup/D drive/Manqi/EM/Figure/Paper/EVAPR_EMixed_scatter_noCSadj.pdf",pros2,width = 15,height = 20)
# 
# ################################# New plot ########################
phat_all_dnam <- lapply(res_Ens_DNAm$allgene_res, function(i) i[["a"]][["p_hat"]][[1]][[1]])
phat_all_rna <- lapply(res_Ens_RNA$allgene_res, function(i) i[["a"]][["p_hat"]][[1]][[1]])
phat_allgene <- append(append(list(EnsDeconv = EnsDeconv_p_fin),phat_all_dnam),phat_all_rna)
names(phat_allgene) <- gsub("\\_300","",names(phat_allgene))
names(phat_allgene) <- gsub("^.*\\_","",names(phat_allgene))
names(phat_allgene) <- gsub("^.*\\.","",names(phat_allgene))
phat_allgene <- append(phat_allgene, list(EMixed = p_emixed))
phat_allgene <- append(phat_allgene, list(EMixed_DNAm = p_dna))
phat_allgene <- append(phat_allgene, list(EMixed_RNA = p_rna2))

# phat_allgene <- lapply(phat_allgene, function(phat){
#   phat <- phat[,c('Astro', 'Micro','Endo' , 'Inh','Exc', 'Oligo','OPC')]
#   phat[,4] <- phat[,4]+phat[,5]
#
#   colnames(phat)[4] <- "Neuro"
#
#   phat[,6] <- phat[,6]+phat[,7]
#   phat <- phat[,-7]
#   phat <- phat[,-5]
#   colnames(phat) =  c("neutrophils","monocytes","Endothelial","lymphocytes","eosinophils")
#   return(phat)
# })

# rownames(frac_atopy) <-  meta_dna_sub$projid
# colnames(frac_atopy)  <- c("neutrophils","Endothelial","monocytes","lymphocytes","eosinophils")
source("~/Manqi/MODE/Revision/getOutput_dontdrop_stromal.R")
library(reshape2)

mean_matrices <- function(list_of_matrices) {
  # Calculate the mean across all matrices in the list
  Reduce("+", list_of_matrices) / length(list_of_matrices)
}

# Step 2: Unlist the list while keeping the names
unlisted_data <- phat_allgene

# Step 3: Split the data by names
split_data <- split(unlisted_data, names(unlisted_data))

# Step 4: Apply the mean function to each group of matrices
mean_data <- lapply(split_data, mean_matrices)

ress <- getOutput(mean_data, true = frac_atopy,trueMet ="EVAPR" )

mae_all <- sapply(mean_data, function(i){
  i <- sum_to_one(i)
  i <- ord_name(i,df_true = frac_atopy)
  return(mean(abs(c(i)-c(frac_atopy))) %>% round(.,2))
})
########## CCC ########
new = ress$com_res %>% group_by(CellType,Method) %>%
  mutate(mCCC = mean(CCC,na.rm = T))  %>%
  dplyr::select(CellType,Method,mCCC) %>% unique()

checkkkk =new %>% group_by(Method) %>%
  mutate(p_mean = mean(mCCC,na.rm = T))
celltype_col2 = pal_simpsons()(12)
pros=new %>% mutate_at("mCCC",as.numeric) %>%
  ggerrorplot("Method", "mCCC",order = levels(reorder(checkkkk$Method, checkkkk$p_mean,order = TRUE)),
              error.plot = "errorbar",desc_stat = "mean_se")+
  geom_point(aes(color =CellType,shape =CellType),size = 6.5)+scale_color_manual(
    values = c("neutrophils" = celltype_col2[1],
               "lymphocytes" = celltype_col2[10],
               "monocytes" = celltype_col2[4],
               "eosinophils" = celltype_col2[5]))+scale_shape_manual(values=c("neutrophils" = 5,
                                                                              "lymphocytes" = 7,
                                                                              "eosinophils" = 8,
                                                                              "monocytes" = 6))+ theme(legend.title = element_blank(),
                                                              legend.text=element_text(size = 23),plot.title = element_text(hjust = 0.5),text = element_text(size = 27))+
  xlab("Deconvolution Method") + ylab("CCC")+
  stat_summary(
    geom = "point",
    shape = 3,
    size = 5,
    fun = "mean",show.legend = F)+
  coord_flip()+
  scale_shape_manual(values =5:8)

phat_all2 <- phat_all_dnam
names(phat_all2) <- gsub("\\_300","",names(phat_all2))
names(phat_all2) <- gsub("^.*\\_","",names(phat_all2))
phat_all2 <- append(list(EMixed_DNAm = p_dna),phat_all2)
ress <- getOutput(phat_all2, true = frac_atopy,trueMet ="EVAPR" )
new = ress$com_res %>% group_by(CellType,Method) %>%
  mutate(mCCC = mean(CCC,na.rm = T))  %>%
  dplyr::select(CellType,Method,mCCC) %>% unique()

checkkkk =new %>% group_by(Method) %>%
  mutate(p_mean = mean(mCCC,na.rm = T))

pros_dnam=new %>% mutate_at("mCCC",as.numeric) %>%
  ggerrorplot("Method", "mCCC",order = levels(reorder(checkkkk$Method, checkkkk$p_mean,order = TRUE)),
              error.plot = "errorbar",desc_stat = "mean_se")+
  geom_point(aes(color =CellType,shape =CellType),size = 6.5)+scale_color_manual(
    values = c("neutrophils" = celltype_col2[1],
               "lymphocytes" = celltype_col2[10],
               "monocytes" = celltype_col2[4],
               "eosinophils" = celltype_col2[5]))+scale_shape_manual(values=c("neutrophils" = 5,
                                                                              "lymphocytes" = 7,
                                                                              "eosinophils" = 8,
                                                                              "monocytes" = 6))+ theme(legend.title = element_blank(),
                                                         legend.text=element_text(size = 23),plot.title = element_text(hjust = 0.5),text = element_text(size = 27))+
  ggtitle("DNAm only") + ylab("CCC")+xlab('Deconvolution Method')+
  stat_summary(
    geom = "point",
    shape = 3,
    size = 5,
    fun = "mean",show.legend = F)+
  coord_flip()+
  scale_shape_manual(values =5:8)


######### RNA
phat_all3 <- phat_all_rna
names(phat_all3) <- gsub("\\_300","",names(phat_all3))
names(phat_all3) <- gsub("^.*\\_","",names(phat_all3))
phat_all3 <- append(list(EMixed_RNA = p_rna2),phat_all3)
ress <- getOutput(phat_all3, true = frac_atopy,trueMet ="EVAPR" )
new = ress$com_res %>% group_by(CellType,Method) %>%
  mutate(mCCC = mean(CCC,na.rm = T))  %>%
  dplyr::select(CellType,Method,mCCC) %>% unique()

checkkkk =new %>% group_by(Method) %>%
  mutate(p_mean = mean(mCCC,na.rm = T))

pros_rna=new %>% mutate_at("mCCC",as.numeric) %>%
  ggerrorplot("Method", "mCCC",order = levels(reorder(checkkkk$Method, checkkkk$p_mean,order = TRUE)),
              error.plot = "errorbar",desc_stat = "mean_se")+
  geom_point(aes(color =CellType,shape =CellType),size = 6.5)+scale_color_manual(
    values = c("neutrophils" = celltype_col2[1],
               "lymphocytes" = celltype_col2[10],
               "monocytes" = celltype_col2[4],
               "eosinophils" = celltype_col2[5]))+scale_shape_manual(values=c("neutrophils" = 5,
                                                                              "lymphocytes" = 7,
                                                                              "eosinophils" = 8,
                                                                              "monocytes" = 6))+ theme(legend.title = element_blank(),
                                                         legend.text=element_text(size = 23),plot.title = element_text(hjust = 0.5),text = element_text(size = 27))+
  ggtitle("RNA only") + ylab("CCC")+xlab('Deconvolution Method')+
  stat_summary(
    geom = "point",
    shape = 3,
    size = 5,
    fun = "mean",show.legend = F)+
  coord_flip()+
  scale_shape_manual(values =5:8)+ theme(plot.margin = margin(10, 10, 10, 10))
pros 
p1 <- ggarrange(pros_rna,pros_dnam,nrow = 1,labels = c('a','b'),common.legend = T,
                font.label = list(size = 30))

ggsave("/storage/windows-backup/D drive/Manqi/EM/Figure/Paper/EVAPR_EMixed_benchmark_dnam_rna_2.pdf",p1,width = 20,height = 8)
# 
# 
res_emixed_p <- reshape2::melt(p_emixed)
colnames(res_emixed_p) <- c("Sample_Name","CellType","p_est")
res_frac_atopy <- reshape2::melt(frac_atopy)
colnames(res_frac_atopy) <- c("Sample_Name","CellType","p_true")
# celltype_col = pal_lancet("lanonc")(9)
mae_value <- mean(abs(p_emixed- frac_atopy), na.rm = TRUE)
p3 <- full_join(res_emixed_p, res_frac_atopy) %>%
  ggscatter(x="p_est",y="p_true",color = "CellType",alpha = 0.8,shape = "CellType",size = 6)+
  stat_cor(method = "pearson", label.x = 0.1, label.y = 0.9,size = 7)+geom_abline(intercept = 0, slope = 1,linetype =2)+coord_equal(xlim=c(0,0.9),ylim=c(0,0.9))+
  xlab("Estimated fraction")+ylab("Measured fraction")+ggtitle("EMixed")+scale_color_manual(
    values = c("neutrophils" = celltype_col2[1],
               "lymphocytes" = celltype_col2[10],
               "monocytes" = celltype_col2[4],
               "eosinophils" = celltype_col2[5]))+scale_shape_manual(values=c("neutrophils" = 5,
                                                                                   "lymphocytes" = 7,
                                                                                   "eosinophils" = 8,
                                                                                   "monocytes" = 6))+
  theme(legend.title = element_blank(),legend.text=element_text(size = 23),plot.title = element_text(hjust = 0.5),text = element_text(size = 27))

p2 <- ggarrange(pros,p3,nrow = 1, labels = c('a','b'),common.legend = T,
                                 font.label = list(size = 30))
ggsave("/storage/windows-backup/D drive/Manqi/EM/Figure/Paper/EVAPR_EMixed_benchmark.pdf",p2,width = 20,height = 8)
# 
# 
# 
# 

######## EMixed DNAm RNA ########
get_sca <- function(p_dna,p_rna,title){
  res_DNAm <- reshape2::melt(p_dna)
  colnames(res_DNAm) <- c("Sample_Name","CellType","p_dna")
  res_rna <- reshape2::melt(p_rna)
  colnames(res_rna) <- c("Sample_Name","CellType","p_rna")
  mean_ccc <-  CTS_CCC(p_dna,p_rna)
  
  
  dat <- full_join(res_DNAm, res_rna)%>%
    mutate(CellType = factor(CellType,level = c("neutrophils","lymphocytes","monocytes","eosinophils"))) %>%
    group_by(CellType) %>%
    mutate(y_min = 0,
           x_min = 0,
           y_max= max(max(p_dna),max(p_rna))+0.05,
           x_max = y_max)
  
  p <- dat%>%
    ggscatter(y="p_dna",x="p_rna",color = "CellType")+
    stat_cor(method = "spearman", size = 5,aes(label = after_stat(r.label)))+
    facet_wrap(~CellType,nrow = 1,scales = "free")+geom_abline(intercept = 0, slope = 1,linetype =2)+theme(legend.position = "none",
                                                                                                           aspect.ratio = 1)+
    ylab("DNAm est. fraction")+xlab("RNA est. fraction")+scale_color_manual(
      values = c("neutrophils" = celltype_col2[1],
                 "lymphocytes" = celltype_col2[10],
                 "monocytes" = celltype_col2[4],
                 "eosinophils" = celltype_col2[5]))+scale_shape_manual(values=c("neutrophils" = 5,
                                                                                "lymphocytes" = 7,
                                                                                "eosinophils" = 8,
                                                                                "monocytes" = 6))+
    theme(axis.text.x = element_text(angle = 45, vjust = 1, hjust=1),
          text = element_text(size = 20),axis.text = element_text(size = 18))+
    ggtitle(paste0(title,": Mean CCC = ",round(mean_ccc,2)))+
    geom_blank(aes(y = y_min)) +
    geom_blank(aes(y = y_max))+
    geom_blank(aes(x = x_min)) +
    geom_blank(aes(x = x_max))
  return(p)
}
emixed_sca <- get_sca(p_dna = p_dna,p_rna2,"EMixed")
ciber_sca <- get_sca(p_dna = phat_all2$CIBERSORT,phat_all3$CIBERSORT,"CIBERSORT")
epic_sca <- get_sca(p_dna = phat_all2$EPIC,phat_all3$EPIC,"EPIC")
dcq_sca <- get_sca(p_dna = phat_all2$DCQ,phat_all3$DCQ,"DCQ")
pfin_sca <- ggarrange(emixed_sca,ciber_sca,epic_sca,dcq_sca,nrow = 4,labels = c("a","b","c","d"),
                  font.label = list(size = 20))
ggsave("/storage/windows-backup/D drive/Manqi/EM/Figure/Paper/EVAPR_DNAm_RNA.pdf",pfin_sca,width = 13,height = 16)



######## Downstream #######
evapr_true_case = as.data.frame(frac_atopy[evapr_atopy_sub_1$studyid,])
evapr_true_ctl = as.data.frame(frac_atopy[evapr_atopy_sub_0$studyid,])


evapr_true_case <- gather(evapr_true_case, cell_type, p_true,  factor_key=TRUE)
evapr_true_case$ind = "Case"
evapr_true_ctl <- gather(evapr_true_ctl, cell_type, p_true,  factor_key=TRUE)
evapr_true_ctl$ind = "Control"

evapr_all = rbind(evapr_true_case,evapr_true_ctl)
evapr_all$cell_type = str_to_title(evapr_all$cell_type)

evapr_all = rbind(evapr_true_case,evapr_true_ctl)
evapr_all$cell_type = str_to_title(evapr_all$cell_type)


evapr_all %>%mutate(cell_type = ifelse(cell_type == "Neutrophils","Neut",ifelse(cell_type == "Lymphocytes","Lymp",ifelse(cell_type =="Monocytes", "Mono",ifelse(cell_type == "Eosinophils","Eosi",cell_type)))),
                    ind = ifelse(ind == "Case","Atopic","Non-Atopic")) %>%  ggboxplot( x = "cell_type", y = "p_true",
                                                                                       color = "ind", palette = "jco",xlab = "")+ stat_compare_means(aes(group = ind,label = ifelse(
                                                                                         p < 1.e-2,
                                                                                         sprintf("p = %2.1e", as.numeric(..p.format..)),
                                                                                         sprintf("p = %5.2f", as.numeric(..p.format..)))),size = 4)+ylab("Estimated fraction")+ theme(axis.text.x = element_text(angle = 90,size = 9),
                                                                                                                                                                                      legend.text=element_text(size=9),
                                                                                                                                                                                      legend.title = element_blank(),
                                                                                                                                                                                      axis.title.y = element_text(size = 9))

#####
library(dplyr)
library(ggpubr)

# Assume your three matrices are named method1, method2, method3
# Each matrix has samples as rows and cell types as columns (including eosinophils)
# Assume `meta_data` has a column `sample` and `atopic` which is either "Atopic" or "Non-Atopic"

# Convert matrices to data frames for easier manipulation
method1_df <- as.data.frame(frac_atopy)
method2_df <- as.data.frame(p_emixed)
method3_df <- as.data.frame(p_dna)
method4_df <- as.data.frame(p_rna2)

# Add a column to each to indicate the method
method1_df$method <- "Measured fraction"
method2_df$method <- "EMixed"
method3_df$method <- "EMixed-DNAm"
method4_df$method <- "EMixed-RNA"
method4_df$sample <- rownames(method4_df)
method3_df$sample <- rownames(method3_df)
method2_df$sample <- rownames(method2_df)
method1_df$sample <- rownames(method1_df)
# Combine the matrices into one long data frame
combined_df <- bind_rows(
  method1_df %>% dplyr::select(studyid = sample, Eosinophils = eosinophils, method),
  method2_df %>% dplyr::select(studyid = sample, Eosinophils = eosinophils, method),
  method3_df %>% dplyr::select(studyid = sample, Eosinophils = eosinophils, method),
  method4_df %>% dplyr::select(studyid = sample, Eosinophils = eosinophils, method)
)
meta_data <- rbind(evapr_atopy_sub_0,evapr_atopy_sub_1)
# Merge with metadata to get the atopic status
combined_df <- combined_df %>%
  left_join(meta_data, by = "studyid")

# Create the boxplot
p <- combined_df %>% mutate(atopy_status = ifelse(atopy_status == "1","Atopic","Non-Atopic")) %>% 
ggboxplot(
  x = "method", 
  y = "Eosinophils", 
  color = "atopy_status", 
  palette = "jco", 
  xlab = "Deconvolution method", 
  ylab = "Eosinophils estimated fraction"
) +
  stat_compare_means(
    aes(group = atopy_status), 
    label = "p.format",
    size = 4
  ) +
  theme(
    axis.text.x = element_text(angle = 45, hjust = 1, size = 9),
    legend.text = element_text(size = 9),
    legend.title = element_blank(),
    axis.title.y = element_text(size = 9)
  )
ggsave("/storage/windows-backup/D drive/Manqi/EM/Figure/Paper/EVAPR_atopy.pdf",p,width = 8,height = 4)
